> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-language/reference/lexical-elements/literals.md).

# Literals

In BoxLang, literals are fixed values that are not variables and do not change. Here are the types of literals in BoxLang:

1. **String literals**: These are sequences of characters. In BoxLang, you can denote them using single or double quotes. For example, `"Hello, World!"` or `'Hello, World!'`.
2. **Numeric literals**: These are integer or floating-point numbers. For example, `123`, `456.789`.
3. **Boolean literals**: These represent truth values and can be either `true` or `false`.
4. **Null literal**: This represents a null value and is denoted by `null`.
5. **Array literals**: These are denoted by square brackets `[]` and can contain a list of values. For example, `[1, 2, 3]`.
6. **Struct literals**: These are denoted by curly braces `{}` and can contain key-value pairs. For example, `{ "key1": "value1", "key2": "value2" }`. An ordered (linked) struct literal can be accomplished using square braces in lieu of curly: `[ "key1": "value1", "key2": "value2" ]`.
7. **Date/Time literals**: These represent a specific point in time. Strings which contain parseable dates can be interpreted as date/time objects in certain contexts. For example, `dateFormat( "2024-05-12", "MM/dd/yyyy" )` will be operated upon as a date object. Note, however, that member date/time functions are not immediately available on a string literal.
8. **Query literals**: These are used to create a query object. They are represented in the format `queryNew("column1,column2", "type1,type2", [ [ "data1", "data2" ] ])`.

Remember, the way literals are used can vary depending on the context within the BoxLang code.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://boxlang.ortusbooks.com/boxlang-language/reference/lexical-elements/literals.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
